<?php

namespace App\Models;

use App\Entities\LojaProduto\LojaProduto;

// use const False\MyClass\true;
class LojaProdutoModel extends ModelEntity {
	protected $table = 'loja_produto';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [
			'id_produto'			,
			'id_status', 
			'descricao',
			'criado_por',
			'data_criacao',
			'hora_criacao',
			'alterado_por',	
			'data_alteracao', 
			'hora_alteracao'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = false;

	public function registerLojaProduto(LojaProduto $tipoExtorno): void {

		$id_new_tipo_extorno = $this->insert( $tipoExtorno->toArray( true ) );
		$tipoExtorno->setId( $id_new_tipo_extorno );

	}

	public function updateLojaByID(int $id_tipo_extorno, LojaProduto $tipo_extorno): bool {

		$data = $tipo_extorno->toArray( true );
		$binds = [ 
				'id_loja_produto' => $id_tipo_extorno
		];
		$sets = $this->generateUpdateSets( $data, $binds );
		$sql = "UPDATE loja_produto $sets WHERE loja_produto.id = :id_loja_produto:";
		$query = $this->db->query( $sql, $binds );
		return $query->connID->affected_rows === 1;

	}

}
